<?php
/**
 * Created by PhpStorm.
 * User: rafaelporto
 * Date: 25/07/2016
 * Time: 11:13
 */

namespace Factory;


class LogFaseTram {

    public function createLogFaseTram($nrOrg, $cdFilial, $nrSoliServ, $dt, $cdFaseTram, $cdOperador, $cdOperResp,
                                      $txacaolftram, $dsAlFaseTram) {

        $entity = new \Teknisa\Model\Teknisa\Entities\Logfasetram();
        $entity->setNrorg($nrOrg);
        $entity->setCdfilial($cdFilial);
        $entity->setNrsoliserv($nrSoliServ);
        $entity->setDtalfasetram($dt);
        $entity->setDtinclusao($dt);
        $entity->setCdfasetram($cdFaseTram);
        $entity->setCdoperador($cdOperador);
        $entity->setCdoperresp($cdOperResp);
        $entity->setTxacaolftram($txacaolftram);
        $entity->setDsalfasetram($dsAlFaseTram);

        return $entity;
    }

    public function createLogFaseTramInsertionQuery($nrOrg, $cdFilial, $nrSoliServ, $dt, $cdFaseTram, $cdOperador,
                                                    $cdOperResp, $txacaolftram, $dsAlFaseTram,$cdOperadorCurrent) {
        //TODO: tirar esse insert na mão.
        $dateTimeFormat = 'DD/MM/YYYY HH24:MI:SS';
        $query = "
          INSERT INTO LOGFASETRAM
            (CDOPERADOR, CDFASETRAM, NRORGULTATU, TXACAOLFTRAM,
            NRORGINCLUSAO, DSALFASETRAM, CDOPERRESP, CDOPERINCLUSAO, DTINCLUSAO,
            CDOPERULTATU, NRSOLISERV, DTALFASETRAM, NRORG, CDFILIAL)
          VALUES
           (:CDOPERADOR, :CDFASETRAM, :NRORGULTATU, :TXACAOLFTRAM,
            :NRORGINCLUSAO, :DSALFASETRAM, :CDOPERRESP, :CDOPERINCLUSAO, TO_DATE(:DTINCLUSAO,'".$dateTimeFormat."'),
            :CDOPERULTATU, :NRSOLISERV, TO_DATE(:DTALFASETRAM,'".$dateTimeFormat."'), :NRORG, :CDFILIAL)";

        $params = array(
            'CDOPERADOR' => $cdOperador,
            'CDFASETRAM' => $cdFaseTram,
            'NRORGULTATU' => $nrOrg,
            'TXACAOLFTRAM' => $txacaolftram,
            'NRORGINCLUSAO' => $nrOrg,
            'DSALFASETRAM' => $dsAlFaseTram,
            'CDOPERRESP' => $cdOperResp,
            'CDOPERINCLUSAO' => $cdOperadorCurrent,
            'DTINCLUSAO' => $dt,
            'CDOPERULTATU' => $cdOperadorCurrent,
            'NRSOLISERV' => $nrSoliServ,
            'DTALFASETRAM' => $dt,
            'NRORG' => $nrOrg,
            'CDFILIAL' => $cdFilial
        );

        return array($query, $params);
    }

    function updateEmailEnv(\Teknisa\Model\Teknisa\Entities\Logfasetram $entity) {

        $entity->setIdemailenv('S');
        
        return $entity;
    }
} 